import { V3LogInfo } from './report-v3';
export declare type LogLevel = 'INFO' | 'WARN' | 'ERROR' | 'OFF';
export default class Logger {
    private token;
    private disableReport;
    private level;
    private prefix;
    private static id;
    private id;
    constructor(token: string, disableReport?: boolean, level?: LogLevel, prefix?: string);
    private getPrintPrefix;
    /**
     * @param  {V3LogInfo} data 上报的数据。
     * @param  {boolean} retry 重试次数，可选，默认为 3。
     * @description 向服务端上报统计信息。
     */
    report(data: V3LogInfo, retry?: number): void;
    /**
     * @param  {unknown[]} ...args
     * @description 输出 info 级别的调试信息。
     */
    info(...args: unknown[]): void;
    /**
     * @param  {unknown[]} ...args
     * @description 输出 warn 级别的调试信息。
     */
    warn(...args: unknown[]): void;
    /**
     * @param  {unknown[]} ...args
     * @description 输出 error 级别的调试信息。
     */
    error(...args: unknown[]): void;
}
