export interface V3LogInfo {
    code: number;
    reqId: string;
    host: string;
    remoteIp: string;
    port: string;
    duration: number;
    time: number;
    bytesSent: number;
    upType: 'jssdk-h5';
    size: number;
}
/**
 * @param  {string} token 上传使用的 token
 * @param  {V3LogInfo} data 上报的统计数据
 * @param  {number} retry 重试的次数，默认值 3
 * @description v3 版本的日志上传接口，参考文档 https://github.com/qbox/product/blob/master/kodo/uplog.md#%E7%89%88%E6%9C%AC-3。
 */
export declare function reportV3(token: string, data: V3LogInfo, retry?: number): void;
